# remember-the-JLPT

## What is it?

remember-the-JLPT is a little python tool that allows to combine the [Remembering the Kanji (RTK)](https://en.wikipedia.org/wiki/Remembering_the_Kanji_and_Remembering_the_Hanzi) technique with the [Japanese Language Proficiency Test (JLPT)](https://www.jlpt.jp/e/) requirements. It also includes the indexes for the French edition of RTK, called [Les Kanjis dans la tête (KDLT)](https://maniette.fr/).

For instance, imagine you're starting the RTK method, but want to work towards the JLPT N4. There's only around 250 kanjis required, but they go up to number 2172 out of 2200. Which pretty much means finishing the book! Since it can take quite a lot of time to get there, this tool can allow you to know which kanjis you should learn for the exam, while using the RTK technique.

This tool outputs a configurable list of kanjis depending on various options, mainly the JLPT level and whether it's from the English or French index. Once you've got this list, you can for example make your own [Anki deck](https://apps.ankiweb.net/). Another option is to work with [Kanji Koohii](https://kanji.koohii.com/), where you can search the indexes or kanjis.

Kanjis are made up of other kanjis learned before, so you will still need to search for previous occurrences in the indices of the original book. But remember-the-JLPT makes it definitely easier to have a kick-start.

## Database information

The database is a CSV file located in the `source` folder. You can also access the formatted ODS version, which you can open with your favorite spreadsheet software. You can also directly work with the ODS file if you wish.

The French book has more kanjis and different indexes from the English original one.

There are some kanjis that are not referenced in the JLPT lists, and those have a JLPT level of 0 in the database. You can query them if needed.

## Configuration

* -jlpt {0,1,2,3,4,5}
    * Choose the JLPT levels you want to output. You can select multiple ones. [Mandatory]
* -ref {KDLT,RTK}
    * Choose whether you want the English (RTK) or French (KDLT) index. [Mandatory]
* -type {name,kanji,number}
    * Choose the output data you want. You can select multiple ones and the order you want. [Mandatory]
* -output {display,file}
    * Output on the standard output or in a file. You can select both option. File will be saved to the `build` folder. [Mandatory]
* -separator
    * The default separator is ", " for a CSV file. You can change it with this parameter. [Optional]

## Example

`python3 .\remember-the-JLPT.py -jlpt 5 4 3 -ref RTK -type number kanji name -output display -separator " - "`

Sample output:
```
[...]
126 - 太 - plump
134 - 川 - stream
137 - 水 - water
142 - 原 - meadow
143 - 願 - petition
144 - 泳 - swim
154 - 活 - lively
155 - 消 - extinguish
[...]
```